<?php
/* --------------------------------------------------------------
   HubCreateOrderStatusCallbackAjaxHandler.inc.php 2017-02-26
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2017 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

use \HubPublic\Http\CurlRequest;

/**
 * Class HubCreateOrderStatusCallbackAjaxHandler
 */
class HubCreateOrderStatusCallbackAjaxHandler extends AjaxHandler
{
	/**
	 * Returns the Permission Status
	 *
	 * @param int $customerId Optional, customer ID that makes the request.
	 *
	 * @return bool Returns whether the module is accessible or not.
	 */
	public function get_permission_status($customerId = null)
	{
		return true;
	}
	
	
	/**
	 * Proceeds with the module execution.
	 *
	 * @return bool Determines if the process was executed successfully.
	 */
	public function proceed()
	{
		$callbackHandler = MainFactory::create('HubCallbackHandler', MainFactory::create('HubServiceFactory'),
		                                       MainFactory::create('HubClientKeyConfiguration'),
		                                       new CurlRequest(), MODULE_PAYMENT_GAMBIO_HUB_IP_LIST_URL);
		
		$response = $callbackHandler->proceedCreateOrderStatusCallback($_SERVER['HTTP_X_CLIENT_KEY'],
		                                                               $this->v_data_array['POST']['order_status_name']);
		
		$this->v_output_buffer = json_encode($response);
		
		return true;
	}
}